program anneau
  implicit none
  include 'mpif.h'
  integer, dimension(MPI_STATUS_SIZE) :: statut
  integer, parameter                  :: etiquette=300
  integer                             :: nb_processus, rang, valeur, num_proc_precedent, num_proc_suivant, code
  integer                             :: i, len
  character *(MPI_MAX_PROCESSOR_NAME)  :: name
  call MPI_INIT(code)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,nb_processus,code)
  call MPI_COMM_RANK(MPI_COMM_WORLD,rang,code)
  call MPI_GET_PROCESSOR_NAME(name, len, code)
  num_proc_precedent=mod(nb_processus+rang-1,nb_processus)
  num_proc_suivant=mod(rang+1,nb_processus)
  if (rang == 0) then
     call MPI_SEND(rang+1000,1,MPI_INTEGER,num_proc_suivant,etiquette,MPI_COMM_WORLD,code)
     call MPI_RECV(valeur,1,MPI_INTEGER,num_proc_precedent,etiquette,MPI_COMM_WORLD,statut,code)
  else
     call MPI_RECV(valeur,1,MPI_INTEGER,num_proc_precedent,etiquette,MPI_COMM_WORLD,statut,code)
     call MPI_SEND(rang+1000,1,MPI_INTEGER,num_proc_suivant,etiquette,MPI_COMM_WORLD,code)
  end if
   print *,'Moi processus ',rang,' du noeud ',trim(name),' j"ai recu la valeur ',valeur,' du processus', num_proc_precedent
  call MPI_FINALIZE(code)
end program anneau
